.\" ====================================================================
.\"  @Troff-man-file{
.\"     author          = "Nelson H. F. Beebe",
.\"     version         = "1.00.0",
.\"     date            = "16 January 1993",
.\"     time            = "17:32:21 MST",
.\"     filename        = "bibparse.man",
.\"     address         = "Center for Scientific Computing
.\"                        Department of Mathematics
.\"                        University of Utah
.\"                        Salt Lake City, UT 84112
.\"                        USA",
.\"     telephone       = "+1 801 581 5254",
.\"     FAX             = "+1 801 581 4148",
.\"     checksum        = "30280 112 447 3847",
.\"     email           = "beebe@math.utah.edu (Internet)",
.\"     codetable       = "ISO/ASCII",
.\"     keywords        = "bibliography, BibTeX, lexical analysis",
.\"     supported       = "yes",
.\"     docstring       = "This file is the UNIX nroff/troff manual
.\"                        page documentation for bibparse, a tool for
.\"                        parsing the lexical analysis output of
.\"                        bibclean or biblex from BibTeX and Scribe
.\"                        bibliography data base files to verify that
.\"                        it conforms to a proposed grammar for
.\"                        BibTeX.
.\"
.\"                        The checksum field above contains a CRC-16
.\"                        checksum as the first value, followed by the
.\"                        equivalent of the standard UNIX wc (word
.\"                        count) utility output of lines, words, and
.\"                        characters.  This is produced by Robert
.\"                        Solovay's checksum utility.",
.\"  }
.\"=====================================================================
.if t .ds Bi B\s-2IB\s+2T\\h'-0.1667m'\\v'0.20v'E\\v'-0.20v'\\h'-0.125m'X
.if n .ds Bi BibTeX
.\"=====================================================================
.TH BIBPARSE 1 "16 January 1993" "Version 1.00.0"
.\"=====================================================================
.SH NAME
bibparse \- reconstruct a BibTeX bibliography data base file from \
bibclean or biblex lexical analysis output
.\"=====================================================================
.SH SYNOPSIS
.B bibparse
.I "<infile"
.nf
or
.fi
.B bibparse
.I "file1 file2 file3 .\|.\|."
.\"=====================================================================
.SH DESCRIPTION
.B bibparse
takes a lexical token stream from
.BR bibclean (1)
or from
.BR biblex (1),
and verifies that it conforms to a proposed
grammar for \*(Bi.
.PP
The only output produced by
.B bibparse
is on the standard error unit, and then only if
grammatical errors are detected.  Silent execution
means a successful parse.
.PP
The program exit code is 0 on a successful parse,
and non-zero otherwise.
.PP
For example, you can syntax check a bibliography
collection by the UNIX pipelines
.RS
.nf
.B "bibclean -no-prettyprint \fI*.bib\fP | bibparse"
.B "biblex \fI*.bib\fP | bibparse"
.fi
.RE
.\"=====================================================================
.SH "SEE ALSO"
.BR bibclean (1),
.BR bibextract (1),
.BR bibindex (1),
.BR biblex (1),
.BR biblook (1),
.BR bibsort (1),
.BR bibtex (1),
.BR bibunlex (1),
.BR citefind (1),
.BR citetags (1),
.BR latex (1),
.BR scribe (1),
.BR tex (1).
.\"=====================================================================
.SH AUTHOR
.nf
Nelson H. F. Beebe
Center for Scientific Computing
Department of Mathematics
University of Utah
Salt Lake City, UT 84112
USA
Tel: +1 801 581 5254
FAX: +1 801 581 4148
Email: <beebe@math.utah.edu>
.fi
.\"=====================================================================
.\" This is for GNU Emacs file-specific customization:
.\" Local Variables:
.\" fill-column: 50
.\" End:
